var issues = {"name":"SqSK","tip":"C:/Users/GTX-10/Dropbox/TCC/workspace/SqSK\\","qtd":361,"children":[{"id":0,"name":"ControllerHTML.java","tip":"src/html/ControllerHTML.java","path":"src/html/ControllerHTML.java","qtd":13,"children":[{"name":"S3008","tip":"Static non-final field names should comply with a naming convention","severity":"MINOR","qtd":1,"children":[{"size":2,"name":15,"tip":"static List&lt;String&gt; sonar_issue_report;","qtd":1}]},{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":10,"children":[{"size":2,"name":13,"tip":"public class ControllerHTML {","qtd":1},{"size":2,"name":21,"tip":"public ControllerHTML()","qtd":1},{"size":2,"name":27,"tip":"public void parse() throws FileNotFoundException {","qtd":1},{"size":2,"name":43,"tip":"public void parseSummary() throws FileNotFoundException{","qtd":1},{"size":2,"name":48,"tip":"public static void newIssue(String key, String rule, String severity, String lineID, int componentID, String isNew)","qtd":1},{"size":2,"name":54,"tip":"public static void newResource(Integer k, String v){","qtd":1},{"size":2,"name":59,"tip":"public static void newRule(String k, String v){","qtd":1},{"size":2,"name":64,"tip":"public static void newRule(String s){","qtd":1},{"size":2,"name":69,"tip":"public static List&lt;Issue&gt; getIssuesList(Severity s , Class c) {","qtd":1},{"size":2,"name":82,"tip":"public static List&lt;String&gt; getRulesFile(String path) throws FileNotFoundException {","qtd":1}]},{"name":"S00117","tip":"Local variable and method parameter names should comply with a naming convention","severity":"MINOR","qtd":1,"children":[{"size":2,"name":44,"tip":"List&lt;String&gt; html_model = ControllerPersistence.parseSummary();","qtd":1}]},{"name":"S2696","tip":"Instance methods should not write to \\\"static\\\" fields","severity":"CRITICAL","qtd":1,"children":[{"size":4,"name":38,"tip":"sonar_issue_report = ControllerPersistence.parseAsListString(path);","qtd":1}]}]},{"id":1,"name":"InputParser.java","tip":"src/html/InputParser.java","path":"src/html/InputParser.java","qtd":20,"children":[{"name":"S1854","tip":"Dead stores should be removed","severity":"MAJOR","qtd":2,"children":[{"size":3,"name":58,"tip":"String s = &quot;&quot;, k = &quot;&quot;, v = &quot;&quot;;","qtd":1},{"size":3,"name":58,"tip":"String s = &quot;&quot;, k = &quot;&quot;, v = &quot;&quot;;","qtd":1}]},{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":2,"children":[{"size":2,"name":9,"tip":"public class InputParser {","qtd":1},{"size":2,"name":16,"tip":"public void run(List&lt;String&gt; html) throws FileNotFoundException","qtd":1}]},{"name":"S1659","tip":"Multiple variables should not be declared on the same line","severity":"MINOR","qtd":6,"children":[{"size":2,"name":58,"tip":"String s = &quot;&quot;, k = &quot;&quot;, v = &quot;&quot;;","qtd":1},{"size":2,"name":58,"tip":"String s = &quot;&quot;, k = &quot;&quot;, v = &quot;&quot;;","qtd":1},{"size":2,"name":111,"tip":"String key, rule, lineID, isNew, severity;","qtd":1},{"size":2,"name":111,"tip":"String key, rule, lineID, isNew, severity;","qtd":1},{"size":2,"name":111,"tip":"String key, rule, lineID, isNew, severity;","qtd":1},{"size":2,"name":111,"tip":"String key, rule, lineID, isNew, severity;","qtd":1}]},{"name":"S134","tip":"Control flow statements \\\"if\\\", \\\"for\\\", \\\"while\\\", \\\"switch\\\" and \\\"try\\\" should not be nested too deeply","severity":"MAJOR","qtd":2,"children":[{"size":3,"name":65,"tip":"if(html.get(i).startsWith(&quot;{ \\&quot;key\\&quot;: \\&quot;&quot;))","qtd":1},{"size":3,"name":119,"tip":"if(html.get(i).startsWith(&quot;{'k':&quot;))","qtd":1}]},{"name":"S1186","tip":"Methods should not be empty","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":11,"tip":"public InputParser()","qtd":1}]},{"name":"ForLoopCounterChangedCheck","tip":"\\\"for\\\" loop stop conditions should be invariant","severity":"MAJOR","qtd":4,"children":[{"size":3,"name":63,"tip":"for(i++;!html.get(i).equals(&quot;}&quot;);i++)","qtd":1},{"size":3,"name":63,"tip":"for(i++;!html.get(i).equals(&quot;}&quot;);i++)","qtd":1},{"size":3,"name":117,"tip":"for(i+=2 ; !html.get(i).contains(&quot;];&quot;) ; i++)","qtd":1},{"size":3,"name":117,"tip":"for(i+=2 ; !html.get(i).contains(&quot;];&quot;) ; i++)","qtd":1}]},{"name":"S1132","tip":"Strings literals should be placed on the left side when checking for equality","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":63,"tip":"for(i++;!html.get(i).equals(&quot;}&quot;);i++)","qtd":1}]},{"name":"S1994","tip":"\\\"for\\\" loop incrementers should modify the variable being tested in the loop\\'s stop condition","severity":"MAJOR","qtd":2,"children":[{"size":3,"name":63,"tip":"for(i++;!html.get(i).equals(&quot;}&quot;);i++)","qtd":1},{"size":3,"name":117,"tip":"for(i+=2 ; !html.get(i).contains(&quot;];&quot;) ; i++)","qtd":1}]}]},{"id":2,"name":"OutputParser.java","tip":"src/html/OutputParser.java","path":"src/html/OutputParser.java","qtd":45,"children":[{"name":"UnusedPrivateMethod","tip":"Unused \\\"private\\\" methods should be removed","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":56,"tip":"private static String getGrid(String grid, float index) {","qtd":1}]},{"name":"MethodCyclomaticComplexity","tip":"Methods should not be too complex","severity":"MAJOR","qtd":3,"children":[{"size":3,"name":162,"tip":"private static void generateLists(List&lt;String&gt; html) {","qtd":1},{"size":3,"name":234,"tip":"private static String getGlypho(Severity s)","qtd":1},{"size":3,"name":336,"tip":"private static List&lt;String&gt; generateReport(List&lt;String&gt; html)","qtd":1}]},{"name":"S1192","tip":"String literals should not be duplicated","severity":"MINOR","qtd":3,"children":[{"size":2,"name":276,"tip":"html = html.concat(item+&quot;&lt;strong&gt;Line: &lt;/strong&gt;&quot;+iu.getLineID()+&quot; - &quot;+iu.getLine()+itemEND);","qtd":1},{"size":2,"name":275,"tip":"html = html.concat(item+&quot;&lt;strong&gt;Class: &lt;/strong&gt;&quot;+iu.getComponent()+itemEND);","qtd":1},{"size":2,"name":277,"tip":"html = html.concat(item+&quot;&lt;strong&gt;Rule: &lt;/strong&gt;&quot;+iu.getRule()+&quot; - &quot;+ControllerIssues.getInstance().getRuleDescription(i.getRule())+itemEND);","qtd":1}]},{"name":"CommentedOutCodeLine","tip":"Sections of code should not be \\\"commented out\\\"","severity":"MAJOR","qtd":2,"children":[{"size":3,"name":282,"tip":"//html = html.concat(item+&quot;&lt;strong&gt;Class: &lt;/strong&gt;&quot;+ControllerIssues.getInstance().getResourceClass(ia.getComponentID())+itemEND);","qtd":1},{"size":3,"name":324,"tip":"//html = html.concat(item+&quot;&lt;strong&gt;Class: &lt;/strong&gt;&quot;+ControllerIssues.getInstance().getResourceClass(ia.getComponentID())+itemEND);","qtd":1}]},{"name":"UselessImportCheck","tip":"Useless imports should be removed","severity":"MINOR","qtd":2,"children":[{"size":2,"name":5,"tip":"import java.util.Calendar;","qtd":1},{"size":2,"name":3,"tip":"import java.text.SimpleDateFormat;","qtd":1}]},{"name":"S1226","tip":"Method parameters, caught exceptions and foreach variables should not be reassigned","severity":"MINOR","qtd":10,"children":[{"size":2,"name":62,"tip":"grid = grid.replace(&quot;#&quot;, &quot;A&quot;);","qtd":1},{"size":2,"name":66,"tip":"grid = grid.replace(&quot;#&quot;, &quot;B&quot;);","qtd":1},{"size":2,"name":70,"tip":"grid = grid.replace(&quot;#&quot;, &quot;C&quot;);","qtd":1},{"size":2,"name":74,"tip":"grid = grid.replace(&quot;#&quot;, &quot;D&quot;);","qtd":1},{"size":2,"name":78,"tip":"grid = grid.replace(&quot;#&quot;, &quot;E&quot;);","qtd":1},{"size":2,"name":85,"tip":"grid = grid.replace(&quot;#&quot;, &quot;A&quot;);","qtd":1},{"size":2,"name":89,"tip":"grid = grid.replace(&quot;#&quot;, &quot;B&quot;);","qtd":1},{"size":2,"name":93,"tip":"grid = grid.replace(&quot;#&quot;, &quot;C&quot;);","qtd":1},{"size":2,"name":97,"tip":"grid = grid.replace(&quot;#&quot;, &quot;D&quot;);","qtd":1},{"size":2,"name":101,"tip":"grid = grid.replace(&quot;#&quot;, &quot;E&quot;);","qtd":1}]},{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":2,"children":[{"size":2,"name":17,"tip":"public class OutputParser {","qtd":1},{"size":2,"name":24,"tip":"public List&lt;String&gt; run(List&lt;String&gt; html)","qtd":1}]},{"name":"S1604","tip":"Anonymous inner classes containing only one method should become lambdas","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":129,"tip":"Arrays.sort(ir, new Comparator&lt;Object[]&gt;()","qtd":1}]},{"name":"S1659","tip":"Multiple variables should not be declared on the same line","severity":"MINOR","qtd":5,"children":[{"size":2,"name":110,"tip":"int KEY = 0, RULE = 1, SEVERITY = 2, NEW = 3, RESOLVED = 4, TOTAL = 5;","qtd":1},{"size":2,"name":110,"tip":"int KEY = 0, RULE = 1, SEVERITY = 2, NEW = 3, RESOLVED = 4, TOTAL = 5;","qtd":1},{"size":2,"name":110,"tip":"int KEY = 0, RULE = 1, SEVERITY = 2, NEW = 3, RESOLVED = 4, TOTAL = 5;","qtd":1},{"size":2,"name":110,"tip":"int KEY = 0, RULE = 1, SEVERITY = 2, NEW = 3, RESOLVED = 4, TOTAL = 5;","qtd":1},{"size":2,"name":110,"tip":"int KEY = 0, RULE = 1, SEVERITY = 2, NEW = 3, RESOLVED = 4, TOTAL = 5;","qtd":1}]},{"name":"S134","tip":"Control flow statements \\\"if\\\", \\\"for\\\", \\\"while\\\", \\\"switch\\\" and \\\"try\\\" should not be nested too deeply","severity":"MAJOR","qtd":5,"children":[{"size":3,"name":171,"tip":"if(s.contains(&quot;NEW&quot;))","qtd":1},{"size":3,"name":182,"tip":"if(s.contains(&quot;NEW&quot;))","qtd":1},{"size":3,"name":193,"tip":"if(s.contains(&quot;NEW&quot;))","qtd":1},{"size":3,"name":204,"tip":"if(s.contains(&quot;NEW&quot;))","qtd":1},{"size":3,"name":215,"tip":"if(s.contains(&quot;NEW&quot;))","qtd":1}]},{"name":"S1186","tip":"Methods should not be empty","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":19,"tip":"public OutputParser()","qtd":1}]},{"name":"S00117","tip":"Local variable and method parameter names should comply with a naming convention","severity":"MINOR","qtd":6,"children":[{"size":2,"name":110,"tip":"int KEY = 0, RULE = 1, SEVERITY = 2, NEW = 3, RESOLVED = 4, TOTAL = 5;","qtd":1},{"size":2,"name":110,"tip":"int KEY = 0, RULE = 1, SEVERITY = 2, NEW = 3, RESOLVED = 4, TOTAL = 5;","qtd":1},{"size":2,"name":110,"tip":"int KEY = 0, RULE = 1, SEVERITY = 2, NEW = 3, RESOLVED = 4, TOTAL = 5;","qtd":1},{"size":2,"name":110,"tip":"int KEY = 0, RULE = 1, SEVERITY = 2, NEW = 3, RESOLVED = 4, TOTAL = 5;","qtd":1},{"size":2,"name":110,"tip":"int KEY = 0, RULE = 1, SEVERITY = 2, NEW = 3, RESOLVED = 4, TOTAL = 5;","qtd":1},{"size":2,"name":110,"tip":"int KEY = 0, RULE = 1, SEVERITY = 2, NEW = 3, RESOLVED = 4, TOTAL = 5;","qtd":1}]},{"name":"S1132","tip":"Strings literals should be placed on the left side when checking for equality","severity":"MAJOR","qtd":3,"children":[{"size":3,"name":112,"tip":"while(!html.get(index).equals(&quot;#LIST_RULES_ISSUES&quot;))","qtd":1},{"size":3,"name":135,"tip":"if(int1[SEVERITY].equals(&quot;&quot;))","qtd":1},{"size":3,"name":137,"tip":"if(int2[SEVERITY].equals(&quot;&quot;))","qtd":1}]},{"name":"S1871","tip":"Two branches in the same conditional structure should not have exactly the same implementation","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":442,"tip":"{","qtd":1}]}]},{"id":3,"name":"Resources.java","tip":"src/html/Resources.java","path":"src/html/Resources.java","qtd":3,"children":[{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":2,"children":[{"size":2,"name":6,"tip":"public class Resources {","qtd":1},{"size":2,"name":10,"tip":"public Resources() {","qtd":1}]},{"name":"S2293","tip":"The diamond operator (\\\"<>\\\") should be used","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":11,"tip":"this.map = new HashMap&lt;Integer, String&gt;();","qtd":1}]}]},{"id":4,"name":"CatalogIssues.java","tip":"src/issues/CatalogIssues.java","path":"src/issues/CatalogIssues.java","qtd":41,"children":[{"name":"S106","tip":"Standard outputs should not be used directly to log anything","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":101,"tip":"System.out.println(&quot;Tamanho: &quot;+issues.size());","qtd":1}]},{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":16,"children":[{"size":2,"name":8,"tip":"public class CatalogIssues {","qtd":1},{"size":2,"name":12,"tip":"public CatalogIssues() {","qtd":1},{"size":2,"name":16,"tip":"public void addIssue(Issue i){","qtd":1},{"size":2,"name":20,"tip":"public Issue getIssue(int i){","qtd":1},{"size":2,"name":24,"tip":"public int size(){","qtd":1},{"size":2,"name":48,"tip":"public int getNumberOfIssuesBySeverity(Severity s){","qtd":1},{"size":2,"name":56,"tip":"public int getNumberOfIssuesByType(Class c) {","qtd":1},{"size":2,"name":66,"tip":"public int getNumberOfIssuesBySeverityType(Severity s, Class c) {","qtd":1},{"size":2,"name":88,"tip":"public void printIssues(List&lt;Issue&gt; issues){","qtd":1},{"size":2,"name":93,"tip":"public void printIssues(Class c) {","qtd":1},{"size":2,"name":99,"tip":"public void printIssues()","qtd":1},{"size":2,"name":144,"tip":"public List&lt;Issue&gt; getIssuesBySeverityType(Severity s, Class c)","qtd":1},{"size":2,"name":173,"tip":"public List&lt;Issue&gt; getIssuesPerResource(int res) {","qtd":1},{"size":2,"name":192,"tip":"public List&lt;Issue&gt; getListOfIssuesPerRule(String key) {","qtd":1},{"size":2,"name":203,"tip":"public List&lt;Object[]&gt; getIssuesPerRule(String key) {","qtd":1},{"size":2,"name":236,"tip":"public Object[][] getIssuesPerRule(Rules rules) {","qtd":1}]},{"name":"S1604","tip":"Anonymous inner classes containing only one method should become lambdas","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":161,"tip":"Collections.sort(list, new Comparator&lt;Issue&gt;(){","qtd":1}]},{"name":"S1659","tip":"Multiple variables should not be declared on the same line","severity":"MINOR","qtd":9,"children":[{"size":2,"name":204,"tip":"int KEY = 0, CLASS = 1, LINEID = 2, LINE = 3, SEVERITY = 4;","qtd":1},{"size":2,"name":204,"tip":"int KEY = 0, CLASS = 1, LINEID = 2, LINE = 3, SEVERITY = 4;","qtd":1},{"size":2,"name":204,"tip":"int KEY = 0, CLASS = 1, LINEID = 2, LINE = 3, SEVERITY = 4;","qtd":1},{"size":2,"name":204,"tip":"int KEY = 0, CLASS = 1, LINEID = 2, LINE = 3, SEVERITY = 4;","qtd":1},{"size":2,"name":237,"tip":"int KEY = 0, RULE = 1, SEVERITY = 2, NEW = 3, RESOLVED = 4, TOTAL = 5;","qtd":1},{"size":2,"name":237,"tip":"int KEY = 0, RULE = 1, SEVERITY = 2, NEW = 3, RESOLVED = 4, TOTAL = 5;","qtd":1},{"size":2,"name":237,"tip":"int KEY = 0, RULE = 1, SEVERITY = 2, NEW = 3, RESOLVED = 4, TOTAL = 5;","qtd":1},{"size":2,"name":237,"tip":"int KEY = 0, RULE = 1, SEVERITY = 2, NEW = 3, RESOLVED = 4, TOTAL = 5;","qtd":1},{"size":2,"name":237,"tip":"int KEY = 0, RULE = 1, SEVERITY = 2, NEW = 3, RESOLVED = 4, TOTAL = 5;","qtd":1}]},{"name":"CommentedOutCodeLine","tip":"Sections of code should not be \\\"commented out\\\"","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":267,"tip":"//o[TOTAL] = (int)o[TOTAL]-1;","qtd":1}]},{"name":"S134","tip":"Control flow statements \\\"if\\\", \\\"for\\\", \\\"while\\\", \\\"switch\\\" and \\\"try\\\" should not be nested too deeply","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":259,"tip":"if(i instanceof IssueAdded)","qtd":1}]},{"name":"S00117","tip":"Local variable and method parameter names should comply with a naming convention","severity":"MINOR","qtd":11,"children":[{"size":2,"name":204,"tip":"int KEY = 0, CLASS = 1, LINEID = 2, LINE = 3, SEVERITY = 4;","qtd":1},{"size":2,"name":204,"tip":"int KEY = 0, CLASS = 1, LINEID = 2, LINE = 3, SEVERITY = 4;","qtd":1},{"size":2,"name":204,"tip":"int KEY = 0, CLASS = 1, LINEID = 2, LINE = 3, SEVERITY = 4;","qtd":1},{"size":2,"name":204,"tip":"int KEY = 0, CLASS = 1, LINEID = 2, LINE = 3, SEVERITY = 4;","qtd":1},{"size":2,"name":204,"tip":"int KEY = 0, CLASS = 1, LINEID = 2, LINE = 3, SEVERITY = 4;","qtd":1},{"size":2,"name":237,"tip":"int KEY = 0, RULE = 1, SEVERITY = 2, NEW = 3, RESOLVED = 4, TOTAL = 5;","qtd":1},{"size":2,"name":237,"tip":"int KEY = 0, RULE = 1, SEVERITY = 2, NEW = 3, RESOLVED = 4, TOTAL = 5;","qtd":1},{"size":2,"name":237,"tip":"int KEY = 0, RULE = 1, SEVERITY = 2, NEW = 3, RESOLVED = 4, TOTAL = 5;","qtd":1},{"size":2,"name":237,"tip":"int KEY = 0, RULE = 1, SEVERITY = 2, NEW = 3, RESOLVED = 4, TOTAL = 5;","qtd":1},{"size":2,"name":237,"tip":"int KEY = 0, RULE = 1, SEVERITY = 2, NEW = 3, RESOLVED = 4, TOTAL = 5;","qtd":1},{"size":2,"name":237,"tip":"int KEY = 0, RULE = 1, SEVERITY = 2, NEW = 3, RESOLVED = 4, TOTAL = 5;","qtd":1}]},{"name":"S1066","tip":"Collapsible \\\"if\\\" statements should be merged","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":184,"tip":"if(((IssueAdded)i).getComponentID()==res){","qtd":1}]}]},{"id":5,"name":"ControllerIssues.java","tip":"src/issues/ControllerIssues.java","path":"src/issues/ControllerIssues.java","qtd":22,"children":[{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":21,"children":[{"size":2,"name":10,"tip":"public class ControllerIssues {","qtd":1},{"size":2,"name":28,"tip":"public void setup()","qtd":1},{"size":2,"name":38,"tip":"public void execute(){","qtd":1},{"size":2,"name":43,"tip":"public void persist() throws IOException {","qtd":1},{"size":2,"name":48,"tip":"public List&lt;Issue&gt; getIssuesBySeverity(Severity s){","qtd":1},{"size":2,"name":51,"tip":"public int getNumberOfIssuesBySeverity(Severity s){","qtd":1},{"size":2,"name":54,"tip":"public int getNumberOfIssuesByType(Class c) {","qtd":1},{"size":2,"name":57,"tip":"public int getNumberOfIssuesBySeverityType(Severity s, Class c){","qtd":1},{"size":2,"name":77,"tip":"public void addIssue(String key, String rule, Severity severity, String component,","qtd":1},{"size":2,"name":88,"tip":"public void addIssue(String key, String rule, Severity severity, int lineID,","qtd":1},{"size":2,"name":97,"tip":"public void addResource(Integer i, String s){","qtd":1},{"size":2,"name":100,"tip":"public String getResourceClass(int i){","qtd":1},{"size":2,"name":103,"tip":"public String getResourcePath(int i){","qtd":1},{"size":2,"name":106,"tip":"public String getResource(int i){","qtd":1},{"size":2,"name":114,"tip":"public void addRule(String k, String v){","qtd":1},{"size":2,"name":117,"tip":"public String getRuleDescription(String rule){","qtd":1},{"size":2,"name":121,"tip":"public void addRule(String s) {","qtd":1},{"size":2,"name":129,"tip":"public List&lt;Object[]&gt; getIssuesPerRule(String key){","qtd":1},{"size":2,"name":133,"tip":"public List&lt;Issue&gt; getListOfIssuesPerRule(String key){","qtd":1},{"size":2,"name":137,"tip":"public List&lt;Issue&gt; getIssuesPerResource(int res){","qtd":1},{"size":2,"name":141,"tip":"public List&lt;Issue&gt; getIssuesBySeverityType(Severity s, Class c) {","qtd":1}]},{"name":"S00107","tip":"Methods should not have too many parameters","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":77,"tip":"public void addIssue(String key, String rule, Severity severity, String component,","qtd":1}]}]},{"id":6,"name":"Indexers.java","tip":"src/issues/Indexers.java","path":"src/issues/Indexers.java","qtd":28,"children":[{"name":"UselessParenthesesCheck","tip":"Useless parentheses around expressions should be removed to prevent any misunderstanding","severity":"MAJOR","qtd":3,"children":[{"size":3,"name":49,"tip":"return (ci.getNumberOfIssuesByType(IssueAdded.class)/(float)ci.getNumberOfIssuesByType(IssueResolved.class));","qtd":1},{"size":3,"name":54,"tip":"return (ci.getNumberOfLocalIssues()/(float)ci.getNumberOfServerIssues());","qtd":1},{"size":3,"name":78,"tip":"return (added/resolved);","qtd":1}]},{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":3,"children":[{"size":2,"name":6,"tip":"public class Indexers {","qtd":1},{"size":2,"name":29,"tip":"public void run(CatalogIssues ca)","qtd":1},{"size":2,"name":108,"tip":"public int getNumberOfIssuesByType(Class c) {","qtd":1}]},{"name":"S1659","tip":"Multiple variables should not be declared on the same line","severity":"MINOR","qtd":13,"children":[{"size":2,"name":23,"tip":"private int BLOCKER = 5000, CRITICAL = 250, MAJOR = 50, MINOR = 15, INFO = 2;","qtd":1},{"size":2,"name":23,"tip":"private int BLOCKER = 5000, CRITICAL = 250, MAJOR = 50, MINOR = 15, INFO = 2;","qtd":1},{"size":2,"name":23,"tip":"private int BLOCKER = 5000, CRITICAL = 250, MAJOR = 50, MINOR = 15, INFO = 2;","qtd":1},{"size":2,"name":23,"tip":"private int BLOCKER = 5000, CRITICAL = 250, MAJOR = 50, MINOR = 15, INFO = 2;","qtd":1},{"size":2,"name":58,"tip":"int aBlocker, aCritical, aMajor, aMinor, aInfo;","qtd":1},{"size":2,"name":58,"tip":"int aBlocker, aCritical, aMajor, aMinor, aInfo;","qtd":1},{"size":2,"name":58,"tip":"int aBlocker, aCritical, aMajor, aMinor, aInfo;","qtd":1},{"size":2,"name":58,"tip":"int aBlocker, aCritical, aMajor, aMinor, aInfo;","qtd":1},{"size":2,"name":59,"tip":"int rBlocker, rCritical, rMajor, rMinor, rInfo;","qtd":1},{"size":2,"name":59,"tip":"int rBlocker, rCritical, rMajor, rMinor, rInfo;","qtd":1},{"size":2,"name":59,"tip":"int rBlocker, rCritical, rMajor, rMinor, rInfo;","qtd":1},{"size":2,"name":59,"tip":"int rBlocker, rCritical, rMajor, rMinor, rInfo;","qtd":1},{"size":2,"name":60,"tip":"float added , resolved;","qtd":1}]},{"name":"S2184","tip":"Math operands should be cast before assignment","severity":"CRITICAL","qtd":2,"children":[{"size":4,"name":74,"tip":"added = aBlocker + aCritical + aMajor + aMinor + aInfo;","qtd":1},{"size":4,"name":75,"tip":"resolved = rBlocker + rCritical + rMajor + rMinor + rInfo;","qtd":1}]},{"name":"S1186","tip":"Methods should not be empty","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":25,"tip":"public Indexers() {","qtd":1}]},{"name":"S1132","tip":"Strings literals should be placed on the left side when checking for equality","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":95,"tip":"if(timeStamp.equals(&quot;&quot;))","qtd":1}]},{"name":"S00116","tip":"Field names should comply with a naming convention","severity":"MINOR","qtd":5,"children":[{"size":2,"name":23,"tip":"private int BLOCKER = 5000, CRITICAL = 250, MAJOR = 50, MINOR = 15, INFO = 2;","qtd":1},{"size":2,"name":23,"tip":"private int BLOCKER = 5000, CRITICAL = 250, MAJOR = 50, MINOR = 15, INFO = 2;","qtd":1},{"size":2,"name":23,"tip":"private int BLOCKER = 5000, CRITICAL = 250, MAJOR = 50, MINOR = 15, INFO = 2;","qtd":1},{"size":2,"name":23,"tip":"private int BLOCKER = 5000, CRITICAL = 250, MAJOR = 50, MINOR = 15, INFO = 2;","qtd":1},{"size":2,"name":23,"tip":"private int BLOCKER = 5000, CRITICAL = 250, MAJOR = 50, MINOR = 15, INFO = 2;","qtd":1}]}]},{"id":7,"name":"Issue.java","tip":"src/issues/Issue.java","path":"src/issues/Issue.java","qtd":7,"children":[{"name":"S106","tip":"Standard outputs should not be used directly to log anything","severity":"MAJOR","qtd":4,"children":[{"size":3,"name":27,"tip":"System.out.println(&quot;--------------------------&quot;);","qtd":1},{"size":3,"name":28,"tip":"System.out.println(this.key);","qtd":1},{"size":3,"name":29,"tip":"System.out.println(this.rule+&quot; -&gt; &quot;+ControllerIssues.getInstance().getRuleDescription(rule));","qtd":1},{"size":3,"name":30,"tip":"System.out.println(this.severity);","qtd":1}]},{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":3,"children":[{"size":2,"name":26,"tip":"public void print() {","qtd":1},{"size":2,"name":3,"tip":"public abstract class Issue {","qtd":1},{"size":2,"name":10,"tip":"public Issue(String key, String rule, Severity severity) {","qtd":1}]}]},{"id":8,"name":"IssueAdded.java","tip":"src/issues/IssueAdded.java","path":"src/issues/IssueAdded.java","qtd":7,"children":[{"name":"S106","tip":"Standard outputs should not be used directly to log anything","severity":"MAJOR","qtd":3,"children":[{"size":3,"name":27,"tip":"System.out.println(&quot;Class: &quot;+ControllerIssues.getInstance().getResourceClass(componentID));","qtd":1},{"size":3,"name":28,"tip":"System.out.println(&quot;Line: &quot;+lineID+&quot; -&gt; &quot;+line.trim());","qtd":1},{"size":3,"name":29,"tip":"System.out.println();","qtd":1}]},{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":4,"children":[{"size":2,"name":3,"tip":"public class IssueAdded extends Issue{","qtd":1},{"size":2,"name":10,"tip":"public IssueAdded(String key, String rule, Severity severity, int lineID, int componentID, String line) {","qtd":1},{"size":2,"name":17,"tip":"public IssueAdded(String key, String rule, Severity severity, int lineID, int componentID) {","qtd":1},{"size":2,"name":24,"tip":"public void print()","qtd":1}]}]},{"id":9,"name":"IssueResolved.java","tip":"src/issues/IssueResolved.java","path":"src/issues/IssueResolved.java","qtd":9,"children":[{"name":"S106","tip":"Standard outputs should not be used directly to log anything","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":25,"tip":"System.out.println();","qtd":1}]},{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":2,"children":[{"size":2,"name":3,"tip":"public class IssueResolved extends Issue{","qtd":1},{"size":2,"name":11,"tip":"public IssueResolved(String key, String rule, Severity severity, String component, int componentID,","qtd":1}]},{"name":"S00107","tip":"Methods should not have too many parameters","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":11,"tip":"public IssueResolved(String key, String rule, Severity severity, String component, int componentID,","qtd":1}]},{"name":"S1068","tip":"Unused \\\"private\\\" fields should be removed","severity":"MAJOR","qtd":5,"children":[{"size":3,"name":5,"tip":"private String component;","qtd":1},{"size":3,"name":6,"tip":"private int componentID;","qtd":1},{"size":3,"name":7,"tip":"private TextRange location;","qtd":1},{"size":3,"name":8,"tip":"private Status status;","qtd":1},{"size":3,"name":9,"tip":"private Type type;","qtd":1}]}]},{"id":10,"name":"IssueUnresolved.java","tip":"src/issues/IssueUnresolved.java","path":"src/issues/IssueUnresolved.java","qtd":9,"children":[{"name":"S106","tip":"Standard outputs should not be used directly to log anything","severity":"MAJOR","qtd":3,"children":[{"size":3,"name":46,"tip":"System.out.println(&quot;Class: &quot;+ControllerIssues.getInstance().getResourceClass(componentID));","qtd":1},{"size":3,"name":47,"tip":"System.out.println(&quot;Line: &quot;+lineID+&quot; -&gt; &quot;+line.trim());","qtd":1},{"size":3,"name":48,"tip":"System.out.println();","qtd":1}]},{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":4,"children":[{"size":2,"name":14,"tip":"public IssueUnresolved(String key, String rule, Severity severity, String component, int componentID,","qtd":1},{"size":2,"name":3,"tip":"public class IssueUnresolved extends Issue{","qtd":1},{"size":2,"name":27,"tip":"public void update(int componentID, int lineID, String line)","qtd":1},{"size":2,"name":43,"tip":"public void print()","qtd":1}]},{"name":"S00107","tip":"Methods should not have too many parameters","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":14,"tip":"public IssueUnresolved(String key, String rule, Severity severity, String component, int componentID,","qtd":1}]},{"name":"S1132","tip":"Strings literals should be placed on the left side when checking for equality","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":36,"tip":"if(line.equals(&quot;&quot;) &amp;&amp; lineID == -1)","qtd":1}]}]},{"id":11,"name":"Rules.java","tip":"src/issues/Rules.java","path":"src/issues/Rules.java","qtd":6,"children":[{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":5,"children":[{"size":2,"name":10,"tip":"public class Rules {","qtd":1},{"size":2,"name":14,"tip":"public Rules()","qtd":1},{"size":2,"name":19,"tip":"public String getRule(String ruleID)","qtd":1},{"size":2,"name":24,"tip":"public void addRule(String ruleID , String ruleDescription)","qtd":1},{"size":2,"name":34,"tip":"public void addRule(String s) {","qtd":1}]},{"name":"S2293","tip":"The diamond operator (\\\"<>\\\") should be used","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":16,"tip":"map =  new HashMap&lt;String, String&gt;();","qtd":1}]}]},{"id":12,"name":"Severity.java","tip":"src/issues/Severity.java","path":"src/issues/Severity.java","qtd":1,"children":[{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":1,"children":[{"size":2,"name":3,"tip":"public enum Severity {","qtd":1}]}]},{"id":13,"name":"Status.java","tip":"src/issues/Status.java","path":"src/issues/Status.java","qtd":1,"children":[{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":1,"children":[{"size":2,"name":3,"tip":"public enum Status {","qtd":1}]}]},{"id":14,"name":"TextRange.java","tip":"src/issues/TextRange.java","path":"src/issues/TextRange.java","qtd":2,"children":[{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":2,"children":[{"size":2,"name":3,"tip":"public class TextRange {","qtd":1},{"size":2,"name":10,"tip":"public TextRange(int startLine, int endLine, int startOffset, int endOffset) {","qtd":1}]}]},{"id":15,"name":"Type.java","tip":"src/issues/Type.java","path":"src/issues/Type.java","qtd":1,"children":[{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":1,"children":[{"size":2,"name":3,"tip":"public enum Type {","qtd":1}]}]},{"id":16,"name":"ControllerJSON.java","tip":"src/json/ControllerJSON.java","path":"src/json/ControllerJSON.java","qtd":15,"children":[{"name":"S1854","tip":"Dead stores should be removed","severity":"MAJOR","qtd":2,"children":[{"size":3,"name":71,"tip":"String request = &quot;&quot; , response = &quot;&quot;;","qtd":1},{"size":3,"name":71,"tip":"String request = &quot;&quot; , response = &quot;&quot;;","qtd":1}]},{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":9,"children":[{"size":2,"name":19,"tip":"public class ControllerJSON {","qtd":1},{"size":2,"name":26,"tip":"public ControllerJSON()","qtd":1},{"size":2,"name":39,"tip":"public static void newIssue(String key, String rule, Severity severity, String component,","qtd":1},{"size":2,"name":69,"tip":"public void parse() throws IOException","qtd":1},{"size":2,"name":83,"tip":"public static List&lt;Issue&gt; getIssuesPerRule(String key){","qtd":1},{"size":2,"name":87,"tip":"public void persist(){","qtd":1},{"size":2,"name":119,"tip":"public static String getResourcePath(int key)","qtd":1},{"size":2,"name":123,"tip":"public static String getRuleDescription(String rule)","qtd":1},{"size":2,"name":128,"tip":"public static String getResourceName(int key) {","qtd":1}]},{"name":"UnusedPrivateMethod","tip":"Unused \\\"private\\\" methods should be removed","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":33,"tip":"private void parseIssues(String jsonRequest) throws IOException","qtd":1}]},{"name":"S1659","tip":"Multiple variables should not be declared on the same line","severity":"MINOR","qtd":1,"children":[{"size":2,"name":71,"tip":"String request = &quot;&quot; , response = &quot;&quot;;","qtd":1}]},{"name":"S00107","tip":"Methods should not have too many parameters","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":39,"tip":"public static void newIssue(String key, String rule, Severity severity, String component,","qtd":1}]},{"name":"HiddenFieldCheck","tip":"Local variables should not shadow class fields","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":74,"tip":"int total = ip.getTotal(response);","qtd":1}]}]},{"id":17,"name":"InputParser.java","tip":"src/json/InputParser.java","path":"src/json/InputParser.java","qtd":3,"children":[{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":3,"children":[{"size":2,"name":13,"tip":"public class InputParser {","qtd":1},{"size":2,"name":21,"tip":"public int getTotal(String jsonResponse)","qtd":1},{"size":2,"name":26,"tip":"public void parseIssues(String jsonResponse)","qtd":1}]}]},{"id":18,"name":"OutputParser.java","tip":"src/json/OutputParser.java","path":"src/json/OutputParser.java","qtd":10,"children":[{"name":"UselessParenthesesCheck","tip":"Useless parentheses around expressions should be removed to prevent any misunderstanding","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":68,"tip":"jIssue.addProperty(&quot;lineID&quot;, (((IssueAdded)i).getLineID()));","qtd":1}]},{"name":"S1854","tip":"Dead stores should be removed","severity":"MAJOR","qtd":5,"children":[{"size":3,"name":29,"tip":"JsonObject jIssue = new JsonObject();","qtd":1},{"size":3,"name":28,"tip":"JsonArray jIssueList = new JsonArray();","qtd":1},{"size":3,"name":27,"tip":"JsonObject jRules = new JsonObject();","qtd":1},{"size":3,"name":26,"tip":"JsonArray jRulesList = new JsonArray();","qtd":1},{"size":3,"name":25,"tip":"JsonObject jResources = new JsonObject();","qtd":1}]},{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":2,"children":[{"size":2,"name":14,"tip":"public class OutputParser {","qtd":1},{"size":2,"name":16,"tip":"public String persist()","qtd":1}]},{"name":"CommentedOutCodeLine","tip":"Sections of code should not be \\\"commented out\\\"","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":83,"tip":"//jResourceList.add(jRulesList);","qtd":1}]},{"name":"S134","tip":"Control flow statements \\\"if\\\", \\\"for\\\", \\\"while\\\", \\\"switch\\\" and \\\"try\\\" should not be nested too deeply","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":60,"tip":"if(i instanceof IssueUnresolved)","qtd":1}]}]},{"id":19,"name":"Request.java","tip":"src/json/Request.java","path":"src/json/Request.java","qtd":2,"children":[{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":2,"children":[{"size":2,"name":8,"tip":"public class Request {","qtd":1},{"size":2,"name":10,"tip":"public String jsonRequest(String request) throws IOException","qtd":1}]}]},{"id":20,"name":"Utils.java","tip":"src/json/Utils.java","path":"src/json/Utils.java","qtd":3,"children":[{"name":"S1118","tip":"Utility classes should not have public constructors","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":3,"tip":"public class Utils {","qtd":1}]},{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":2,"children":[{"size":2,"name":3,"tip":"public class Utils {","qtd":1},{"size":2,"name":5,"tip":"public static String convertStreamToString(java.io.InputStream is) {","qtd":1}]}]},{"id":21,"name":"Properties.java","tip":"src/pluginProperties/Properties.java","path":"src/pluginProperties/Properties.java","qtd":6,"children":[{"name":"S00120","tip":"Package names should comply with a naming convention","severity":"MINOR","qtd":1,"children":[{"size":2,"name":1,"tip":"package pluginProperties;","qtd":1}]},{"name":"S1118","tip":"Utility classes should not have public constructors","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":10,"tip":"public class Properties {","qtd":1}]},{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":2,"children":[{"size":2,"name":10,"tip":"public class Properties {","qtd":1},{"size":2,"name":73,"tip":"public static void parse(String path) throws FileNotFoundException","qtd":1}]},{"name":"S1192","tip":"String literals should not be duplicated","severity":"MINOR","qtd":2,"children":[{"size":2,"name":14,"tip":"if(local.startsWith(&quot;serverURL=&quot;))","qtd":1},{"size":2,"name":18,"tip":"else if(local.startsWith(&quot;analyserPath=&quot;))","qtd":1}]}]},{"id":22,"name":"ConfigProjeto.java","tip":"src/project/ConfigProjeto.java","path":"src/project/ConfigProjeto.java","qtd":4,"children":[{"name":"S106","tip":"Standard outputs should not be used directly to log anything","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":46,"tip":"System.out.println(&quot;XML generated!&quot;);","qtd":1}]},{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":2,"children":[{"size":2,"name":3,"tip":"public class ConfigProjeto {","qtd":1},{"size":2,"name":20,"tip":"public static String geraXML(String projectKey, String projectName, Float projectVersion)","qtd":1}]},{"name":"CommentedOutCodeLine","tip":"Sections of code should not be \\\"commented out\\\"","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":6,"tip":"private String projectKey;","qtd":1}]}]},{"id":23,"name":"ControllerScanner.java","tip":"src/scanner/ControllerScanner.java","path":"src/scanner/ControllerScanner.java","qtd":4,"children":[{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":3,"children":[{"size":2,"name":9,"tip":"public class ControllerScanner {","qtd":1},{"size":2,"name":17,"tip":"public void setup()","qtd":1},{"size":2,"name":36,"tip":"public void run(boolean preview) throws IOException","qtd":1}]},{"name":"S1172","tip":"Unused method parameters should be removed","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":36,"tip":"public void run(boolean preview) throws IOException","qtd":1}]}]},{"id":24,"name":"Scan.java","tip":"src/scanner/Scan.java","path":"src/scanner/Scan.java","qtd":9,"children":[{"name":"S1226","tip":"Method parameters, caught exceptions and foreach variables should not be reassigned","severity":"MINOR","qtd":1,"children":[{"size":2,"name":31,"tip":"caminhoScanner = caminhoScanner.concat(Constants.PATH+Constants.SONAR_SCANNER+&quot;.bat&quot;);","qtd":1}]},{"name":"S1854","tip":"Dead stores should be removed","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":13,"tip":"Scanner s = null;","qtd":1}]},{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":3,"children":[{"size":2,"name":9,"tip":"public class Scan {","qtd":1},{"size":2,"name":11,"tip":"public void run(String path) throws IOException","qtd":1},{"size":2,"name":25,"tip":"public String generateScanner(String caminhoProjeto, String caminhoScanner, String params, boolean preview)","qtd":1}]},{"name":"S1192","tip":"String literals should not be duplicated","severity":"MINOR","qtd":2,"children":[{"size":2,"name":33,"tip":"cmd = cmd.concat(&quot;@echo.&quot;+System.lineSeparator());","qtd":1},{"size":2,"name":29,"tip":"if(System.getProperty(&quot;os.name&quot;).contains(&quot;Windows&quot;))","qtd":1}]},{"name":"S00108","tip":"Nested blocks of code should not be left empty","severity":"MAJOR","qtd":2,"children":[{"size":3,"name":48,"tip":"{","qtd":1},{"size":3,"name":52,"tip":"{","qtd":1}]}]},{"id":25,"name":"ControllerPersistence.java","tip":"src/stream/ControllerPersistence.java","path":"src/stream/ControllerPersistence.java","qtd":13,"children":[{"name":"S1118","tip":"Utility classes should not have public constructors","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":11,"tip":"public class ControllerPersistence {","qtd":1}]},{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":12,"children":[{"size":2,"name":11,"tip":"public class ControllerPersistence {","qtd":1},{"size":2,"name":13,"tip":"public static void persistConfigServerFile(String command){","qtd":1},{"size":2,"name":17,"tip":"public static void persistConfigServerFile(String path, String command){","qtd":1},{"size":2,"name":24,"tip":"public static void persistConfigScannerFile(String command , boolean preview){","qtd":1},{"size":2,"name":31,"tip":"public static void persistConfigScannerFile(String path, String command){","qtd":1},{"size":2,"name":40,"tip":"public static void generateHTMLReport(List&lt;String&gt; html){","qtd":1},{"size":2,"name":44,"tip":"public static void persist(Rules rules) {","qtd":1},{"size":2,"name":49,"tip":"public static List&lt;String&gt; parseAsListString(String path) throws FileNotFoundException {","qtd":1},{"size":2,"name":53,"tip":"public static void persistJson(String json) {","qtd":1},{"size":2,"name":58,"tip":"public static void persistLog(List&lt;String&gt; logs) {","qtd":1},{"size":2,"name":62,"tip":"public static List&lt;String&gt; parseSummary() throws FileNotFoundException {","qtd":1},{"size":2,"name":66,"tip":"public static void persist(Indexers i) throws IOException","qtd":1}]}]},{"id":26,"name":"Persistence.java","tip":"src/stream/Persistence.java","path":"src/stream/Persistence.java","qtd":24,"children":[{"name":"S2093","tip":"Try-with-resources should be used","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":154,"tip":"try {","qtd":1}]},{"name":"S1118","tip":"Utility classes should not have public constructors","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":24,"tip":"public class Persistence {","qtd":1}]},{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":6,"children":[{"size":2,"name":24,"tip":"public class Persistence {","qtd":1},{"size":2,"name":80,"tip":"public static void persist(String path, String command)","qtd":1},{"size":2,"name":97,"tip":"public static void persist(String path, List&lt;String&gt; lines)","qtd":1},{"size":2,"name":117,"tip":"public static void persistRules(Rules rules)","qtd":1},{"size":2,"name":137,"tip":"public static List&lt;String&gt; getFileAsListString(String path) throws FileNotFoundException {","qtd":1},{"size":2,"name":152,"tip":"public static void persist(String path, Indexers i) throws IOException {","qtd":1}]},{"name":"S00122","tip":"Statements should be on separate lines","severity":"MINOR","qtd":1,"children":[{"size":2,"name":172,"tip":"if (bw != null) try {","qtd":1}]},{"name":"S2095","tip":"Resources should be closed","severity":"BLOCKER","qtd":2,"children":[{"size":5,"name":178,"tip":"FileWriter fw = new FileWriter(new File(path));","qtd":1},{"size":5,"name":156,"tip":"bw = new BufferedWriter(new FileWriter(path, true));","qtd":1}]},{"name":"S1192","tip":"String literals should not be duplicated","severity":"MINOR","qtd":2,"children":[{"size":2,"name":64,"tip":"if(System.getProperty(&quot;os.name&quot;).contains(&quot;Windows&quot;))","qtd":1},{"size":2,"name":83,"tip":"Logger.getInstance().log(&quot;Trying to persist file: &quot;+path);","qtd":1}]},{"name":"S1166","tip":"Exception handlers should preserve the original exceptions","severity":"MAJOR","qtd":5,"children":[{"size":3,"name":90,"tip":"} catch (IOException e) {","qtd":1},{"size":3,"name":109,"tip":"} catch (IOException e) {","qtd":1},{"size":3,"name":129,"tip":"} catch (IOException e) {","qtd":1},{"size":3,"name":169,"tip":"} catch (IOException ioe) {","qtd":1},{"size":3,"name":174,"tip":"} catch (IOException ioe2) {","qtd":1}]},{"name":"S1135","tip":"\\\"TODO\\\" tags should be handled","severity":"INFO","qtd":2,"children":[{"size":1,"name":110,"tip":"// TODO Auto-generated catch block","qtd":1},{"size":1,"name":130,"tip":"// TODO Auto-generated catch block","qtd":1}]},{"name":"S1147","tip":"Exit methods should not be called","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":93,"tip":"Runtime.getRuntime().exit(0);","qtd":1}]},{"name":"S1148","tip":"Throwable.printStackTrace(...) should not be called","severity":"CRITICAL","qtd":3,"children":[{"size":4,"name":111,"tip":"e.printStackTrace();","qtd":1},{"size":4,"name":131,"tip":"e.printStackTrace();","qtd":1},{"size":4,"name":170,"tip":"ioe.printStackTrace();","qtd":1}]}]},{"id":27,"name":"Constants.java","tip":"src/utils/Constants.java","path":"src/utils/Constants.java","qtd":23,"children":[{"name":"S1118","tip":"Utility classes should not have public constructors","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":3,"tip":"public class Constants {","qtd":1}]},{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":8,"children":[{"size":2,"name":3,"tip":"public class Constants {","qtd":1},{"size":2,"name":5,"tip":"public static String projectKey = &quot;&quot;;","qtd":1},{"size":2,"name":6,"tip":"public static String projectPath = &quot;&quot;;","qtd":1},{"size":2,"name":7,"tip":"public static String projectSource = &quot;&quot;;","qtd":1},{"size":2,"name":9,"tip":"public static String localServerURL = &quot;&quot;;","qtd":1},{"size":2,"name":10,"tip":"public static String localAnalyserPath = &quot;&quot;;","qtd":1},{"size":2,"name":12,"tip":"public static String externalServerURL = &quot;&quot;;","qtd":1},{"size":2,"name":13,"tip":"public static String externalAnalyserPath = &quot;&quot;;","qtd":1}]},{"name":"ClassVariableVisibilityCheck","tip":"Class variable fields should not have public accessibility","severity":"MAJOR","qtd":7,"children":[{"size":3,"name":5,"tip":"public static String projectKey = &quot;&quot;;","qtd":1},{"size":3,"name":6,"tip":"public static String projectPath = &quot;&quot;;","qtd":1},{"size":3,"name":7,"tip":"public static String projectSource = &quot;&quot;;","qtd":1},{"size":3,"name":9,"tip":"public static String localServerURL = &quot;&quot;;","qtd":1},{"size":3,"name":10,"tip":"public static String localAnalyserPath = &quot;&quot;;","qtd":1},{"size":3,"name":12,"tip":"public static String externalServerURL = &quot;&quot;;","qtd":1},{"size":3,"name":13,"tip":"public static String externalAnalyserPath = &quot;&quot;;","qtd":1}]},{"name":"S1444","tip":"\\\"public static\\\" fields should be constant","severity":"CRITICAL","qtd":7,"children":[{"size":4,"name":5,"tip":"public static String projectKey = &quot;&quot;;","qtd":1},{"size":4,"name":6,"tip":"public static String projectPath = &quot;&quot;;","qtd":1},{"size":4,"name":7,"tip":"public static String projectSource = &quot;&quot;;","qtd":1},{"size":4,"name":9,"tip":"public static String localServerURL = &quot;&quot;;","qtd":1},{"size":4,"name":10,"tip":"public static String localAnalyserPath = &quot;&quot;;","qtd":1},{"size":4,"name":12,"tip":"public static String externalServerURL = &quot;&quot;;","qtd":1},{"size":4,"name":13,"tip":"public static String externalAnalyserPath = &quot;&quot;;","qtd":1}]}]},{"id":28,"name":"Logger.java","tip":"src/utils/Logger.java","path":"src/utils/Logger.java","qtd":6,"children":[{"name":"S106","tip":"Standard outputs should not be used directly to log anything","severity":"MAJOR","qtd":2,"children":[{"size":3,"name":30,"tip":"System.out.println(s);","qtd":1},{"size":3,"name":39,"tip":"System.err.println(err);","qtd":1}]},{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":4,"children":[{"size":2,"name":9,"tip":"public class Logger {","qtd":1},{"size":2,"name":26,"tip":"public void log(String s)","qtd":1},{"size":2,"name":35,"tip":"public void warn(String err)","qtd":1},{"size":2,"name":44,"tip":"public void persist()","qtd":1}]}]},{"id":29,"name":"Program.java","tip":"src/utils/Program.java","path":"src/utils/Program.java","qtd":12,"children":[{"name":"S00112","tip":"Generic exceptions should never be thrown","severity":"CRITICAL","qtd":1,"children":[{"size":4,"name":26,"tip":"public void start() throws Exception","qtd":1}]},{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":7,"children":[{"size":2,"name":13,"tip":"public class Program {","qtd":1},{"size":2,"name":36,"tip":"public void scan() throws IOException","qtd":1},{"size":2,"name":19,"tip":"public Program()","qtd":1},{"size":2,"name":26,"tip":"public void start() throws Exception","qtd":1},{"size":2,"name":43,"tip":"public void parse() throws IOException","qtd":1},{"size":2,"name":51,"tip":"public void execute()","qtd":1},{"size":2,"name":57,"tip":"public void persist() throws IOException {","qtd":1}]},{"name":"UselessImportCheck","tip":"Useless imports should be removed","severity":"MINOR","qtd":2,"children":[{"size":2,"name":3,"tip":"import java.io.FileNotFoundException;","qtd":1},{"size":2,"name":6,"tip":"import javax.swing.text.html.CSS;","qtd":1}]},{"name":"S1135","tip":"\\\"TODO\\\" tags should be handled","severity":"INFO","qtd":2,"children":[{"size":1,"name":32,"tip":"//TODO executar no linux","qtd":1},{"size":1,"name":39,"tip":"//TODO executar no linux","qtd":1}]}]},{"id":30,"name":"StartTest.java","tip":"src/utils/StartTest.java","path":"src/utils/StartTest.java","qtd":12,"children":[{"name":"S106","tip":"Standard outputs should not be used directly to log anything","severity":"MAJOR","qtd":1,"children":[{"size":3,"name":19,"tip":"System.out.println(&quot;fim&quot;);","qtd":1}]},{"name":"UndocumentedApi","tip":"Public types, methods and fields (API) should be documented with Javadoc","severity":"MINOR","qtd":2,"children":[{"size":2,"name":8,"tip":"public class StartTest {","qtd":1},{"size":2,"name":11,"tip":"public void testStart() {","qtd":1}]},{"name":"S1166","tip":"Exception handlers should preserve the original exceptions","severity":"MAJOR","qtd":3,"children":[{"size":3,"name":20,"tip":"} catch (FileNotFoundException e) {","qtd":1},{"size":3,"name":24,"tip":"} catch (IOException e) {","qtd":1},{"size":3,"name":28,"tip":"catch (Exception e) {","qtd":1}]},{"name":"S2147","tip":"Catches should be combined","severity":"MAJOR","qtd":2,"children":[{"size":3,"name":24,"tip":"} catch (IOException e) {","qtd":1},{"size":3,"name":28,"tip":"catch (Exception e) {","qtd":1}]},{"name":"S1135","tip":"\\\"TODO\\\" tags should be handled","severity":"INFO","qtd":1,"children":[{"size":1,"name":25,"tip":"// TODO Auto-generated catch block","qtd":1}]},{"name":"S1148","tip":"Throwable.printStackTrace(...) should not be called","severity":"CRITICAL","qtd":3,"children":[{"size":4,"name":22,"tip":"e.printStackTrace();","qtd":1},{"size":4,"name":26,"tip":"e.printStackTrace();","qtd":1},{"size":4,"name":30,"tip":"e.printStackTrace();","qtd":1}]}]}]};
var name = issues["name"];
var width = 960,
height = 700,
radius = Math.min(width, height) / 2,
//new
colors = {
	'BLOCKER': '#e00',
	'CRITICAL': '#f77700',
	'MAJOR': '#FBB917',
	'MINOR': '#80cc00',
	'INFO': '#0a0'
},
// colors = {'BLOCKER': 'red', 'CRITICAL': '#e00', 'MAJOR': '#f77700', 'MINOR': '#EAC117', 'INFO': '#0a0' },
colorOpacity = 0.9;
//endnew

getColor = function (d) {
	var flag;
	if (d.name === name) {
		return '#081d68';
	} else if (d.severity in colors) {
		return colors[d.severity];
	} else {
		//flag = '#7E7F7E';
		flag = colorScale(d.name);
		while (d.parent.name !== name) {
			if (d.parent.severity in colors) {
				flag = colors[d.parent.severity];
				break;
			} else {
				d = d.parent;
			}
		}
		return flag;
	}
};

var x = d3.scale.linear()
	.range([0, 2 * Math.PI]);

var y = d3.scale.linear()
	.range([0, radius]);

//var colorScale = d3.scale.category20b();
var colorScale = d3.scale.ordinal()
	//.range(["#5687d1","#7b615c","#de783b","#6ab975","#a173d1","#bbbbbb"]);
	.range(["#ffffd9", "#edf8b1", "#c7e9b4", "#7fcdbb", "#41b6c4", "#1d91c0", "#225ea8", "#253494"]);
var svg = d3.select("#sunburst").append("svg")
	.attr("width", width)
	.attr("height", height)
	.append("g")
	.attr("transform", "translate(" + width / 2 + "," + (height / 2 + 10) + ")");

var partition = d3.layout.partition()
	.value(function (d) {
		return d.size;
	});

var arc = d3.svg.arc()
	.startAngle(function (d) {
		return Math.max(0, Math.min(2 * Math.PI, x(d.x)));
	})
	.endAngle(function (d) {
		return Math.max(0, Math.min(2 * Math.PI, x(d.x + d.dx)));
	})
	.innerRadius(function (d) {
		return Math.max(0, y(d.y));
	})
	.outerRadius(function (d) {
		return Math.max(0, y(d.y + d.dy));
	});

//d3.json(flare, function(flare) {
var g = svg.selectAll("g")
	.data(partition.nodes(issues))
	.enter().append("g");

var tip = d3.tip()
	.attr('class', 'd3-tip')
	.offset([-10, 0])
	.html(function (d) {
		if (d.tip != null) {
			switch (d.size) {
			case 1: {
					return "<span style='color:green' class='glyphicon glyphicon-circle-arrow-down'></span>" + "  " + d.name + " -> " + d.tip;
					break;
				}
			case 2: {
					return "<span style='color:green' class='glyphicon glyphicon-menu-down'></span>" + "  " + d.name + " -> " + d.tip;
					break;
				}
			case 3: {
					return "<span style='color:red' class='glyphicon glyphicon-menu-up'></span>" + "  " + d.name + " -> " + d.tip;
					break;
				}
			case 4: {
					return "<span style='color:red' class='glyphicon glyphicon-circle-arrow-up'></span>" + "  " + d.name + " -> " + d.tip;
					break;
				}
			case 5: {
					return "<span style='color:red' class='glyphicon glyphicon-exclamation-sign'></span>" + "  " + d.name + " -> " + d.tip;
					break;
				}
			default: {
					return "<span style='color:white'>" + d.tip + "</span>"
				}

			}

		} else
			return "<span style='color:white'>" + d.name + "</span>";

	});

svg.call(tip);

var path = g.append("path")
	.attr("d", arc)
	//.style("fill", function(d) { return color((d.children ? d : d.parent).name); })

	.style("fill", function (d) {
		return getColor(d);
	})
	.style("opacity", colorOpacity)

	.on("click", click)
	.on('mouseover', tip.show)
	.on('mouseout', tip.hide)
	
	.attr("qtd",function(d) {
		
		return d.qtd})
	;

var text = g.append("text")
	.attr("transform", function (d) {
		return "rotate(" + computeTextRotation(d) + ")";
	})
	.attr("x", function (d) {
		return y(d.y);
	})
	.attr("dx", "6") // margin
	.attr("dy", ".35em") // vertical-align
	.text(function (d) {
		return d.name;
	});

text.each(function (d) {
	d3.select()
});

function click(d) {
	// fade out all text elements

	text.transition().attr("opacity", 0);
	console.log(d3.select(this).attr("qtd"));
	d3.select("#G1").html(d3.select(this).attr("qtd"));
	path.transition()
	.duration(750)
	.attrTween("d", arcTween(d))
	.each("end", function (e, i) {
		// check if the animated element's data e lies within the visible angle span given in d
		if (e.x >= d.x && e.x < (d.x + d.dx)) {
			// get a selection of the associated text element
			var arcText = d3.select(this.parentNode).select("text");

			// fade in the text element and recalculate positions
			arcText.transition().duration(750)
			.attr("opacity", 1)
			.attr("transform", function () {
				return "rotate(" + computeTextRotation(e) + ")"
			})
			.attr("x", function (d) {
				return y(d.y);
			});

		}
	});
}
//});

d3.select(self.frameElement).style("height", height + "px");

// Interpolate the scales!
function arcTween(d) {
	var xd = d3.interpolate(x.domain(), [d.x, d.x + d.dx]),
	yd = d3.interpolate(y.domain(), [d.y, 1]),
	yr = d3.interpolate(y.range(), [d.y ? 20 : 0, radius]);
	return function (d, i) {
		return i
		 ? function (t) {
			return arc(d);
		}
		 : function (t) {
			x.domain(xd(t));
			y.domain(yd(t)).range(yr(t));
			return arc(d);
		};
	};
}

function computeTextRotation(d) {
	return (x(d.x + d.dx / 2) - Math.PI / 2) / Math.PI * 180;
}
